/* Generated by re2c 0.12.3 */
#line 1 "mwlib/_uscan.re"
// -*- mode: c++ -*-
// Copyright (c) 2007-2009 PediaPress GmbH
// See README.txt for additional licensing information.

#include <Python.h>

#include <iostream>
#include <assert.h>
#include <vector>
using namespace std;

#define RET(x) {found(x); return x;}

typedef enum {
	t_end,
	t_text,
	t_entity,
	t_special,
	t_magicword,
	t_comment,
	t_2box_open,   // [[
	t_2box_close,  // ]]
	t_http_url,
	t_break,
	t_begin_table,
	t_end_table,
	t_html_tag,
	t_singlequote,
	t_pre,
	t_section,
	t_section_end,
	t_item,
	t_colon,
	t_semicolon,
	t_hrule,
	t_newline,
	t_column,
	t_row,
	t_tablecaption,
	t_urllink,
	t_uniq,
} mwtok;

struct Token
{
	int type;
	int start;
	int len;
};

class Scanner
{
public:

	Scanner(Py_UNICODE *_start, Py_UNICODE *_end) {
		source = start = _start;
		end = _end;
		cursor = start;
		line_startswith_section = -1;
		tablemode=0;
	}

	int found(mwtok val) {
		if (val==t_text && tokens.size()) {
			Token &previous_token (tokens[tokens.size()-1]);
			if (previous_token.type==val) {
				previous_token.len += cursor-start;
				return tokens.size()-1;
			}
		}
		Token t;
		t.type = val;
		t.start = (start-source);
		t.len = cursor-start;			
		tokens.push_back(t);
		return tokens.size()-1;
	}

	bool bol() {
		if ((start==source) || (start[-1]=='\n')) {
			memset(&lineflags, 0, sizeof(lineflags));
			return true;
		} else {
			return false;
		}
	}

	bool eol() const {
		return *cursor=='\n' || *cursor==0;
	}

	void newline() {
		if (line_startswith_section>=0) {
			tokens[line_startswith_section].type = t_text;
		}
		line_startswith_section = -1;
	}

	inline int scan();

	Py_UNICODE *source;

	Py_UNICODE *start;
	Py_UNICODE *cursor;
	Py_UNICODE *end;
	vector<Token> tokens;

	int line_startswith_section;
	int tablemode;
	struct {
		int rowchar;
	} lineflags;
};


int Scanner::scan()
{
	start=cursor;
	
	Py_UNICODE *marker=cursor;

	Py_UNICODE *save_cursor = cursor;


#define YYCTYPE         Py_UNICODE
#define YYCURSOR        cursor
#define YYMARKER	marker
#define YYLIMIT   (end)
// #define YYFILL(n) return 0;

#line 133 "mwlib/_uscan.re"


/*
  the re2c manpage says:
  "The user must arrange for a sentinel token to appear at the end of input"
  \000 is our sentinel token.
*/

#line 171 "mwlib/_uscan.re"

	if (!bol()) {
		goto not_bol;
	}

#line 149 "mwlib/_uscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	yych = *YYCURSOR;
	if(yych <= ',') {
		if(yych <= '!') {
			if(yych <= 0x0009) {
				if(yych <= 0x0008) goto yy16;
			} else {
				if(yych <= 0x001F) goto yy16;
				if(yych <= ' ') goto yy4;
				goto yy11;
			}
		} else {
			if(yych <= '#') {
				if(yych <= '"') goto yy16;
				goto yy14;
			} else {
				if(yych == '*') goto yy14;
				goto yy16;
			}
		}
	} else {
		if(yych <= '<') {
			if(yych <= '9') {
				if(yych <= '-') goto yy15;
				goto yy16;
			} else {
				if(yych <= ':') goto yy6;
				if(yych <= ';') goto yy14;
				goto yy16;
			}
		} else {
			if(yych <= 'z') {
				if(yych <= '=') goto yy12;
				goto yy16;
			} else {
				if(yych <= '{') goto yy8;
				if(yych <= '|') goto yy9;
				goto yy16;
			}
		}
	}
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '!') {
		if(yych == 0x0009) goto yy44;
		if(yych >= ' ') goto yy44;
	} else {
		if(yych <= ':') {
			if(yych >= ':') goto yy44;
		} else {
			if(yych <= 'z') goto yy3;
			if(yych <= '|') goto yy44;
		}
	}
yy3:
#line 223 "mwlib/_uscan.re"
	{goto not_bol;}
#line 210 "mwlib/_uscan.cc"
yy4:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '!') {
		if(yych == 0x0009) goto yy44;
		if(yych >= ' ') goto yy44;
	} else {
		if(yych <= ':') {
			if(yych >= ':') goto yy44;
		} else {
			if(yych <= 'z') goto yy5;
			if(yych <= '|') goto yy44;
		}
	}
yy5:
#line 215 "mwlib/_uscan.re"
	{RET(t_pre);}
#line 228 "mwlib/_uscan.cc"
yy6:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == ':') goto yy39;
	if(yych == '{') goto yy41;
	goto yy24;
yy7:
#line 220 "mwlib/_uscan.re"
	{RET(t_item);}
#line 238 "mwlib/_uscan.cc"
yy8:
	yych = *++YYCURSOR;
	if(yych == '|') goto yy37;
	goto yy3;
yy9:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= ',') {
		if(yych == '+') goto yy29;
	} else {
		if(yych <= '-') goto yy32;
		if(yych == '}') goto yy35;
	}
yy10:
#line 191 "mwlib/_uscan.re"
	{
		if (tablemode) {
		        lineflags.rowchar=cursor[-1];
			RET(t_column);
		}

		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 265 "mwlib/_uscan.cc"
yy11:
	yych = *++YYCURSOR;
	goto yy10;
yy12:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '=') goto yy27;
	goto yy26;
yy13:
#line 216 "mwlib/_uscan.re"
	{
			line_startswith_section = found(t_section);
			return t_section;
		}
#line 279 "mwlib/_uscan.cc"
yy14:
	yych = *++YYCURSOR;
	goto yy24;
yy15:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '-') goto yy17;
	goto yy3;
yy16:
	yych = *++YYCURSOR;
	goto yy3;
yy17:
	yych = *++YYCURSOR;
	if(yych == '-') goto yy19;
yy18:
	YYCURSOR = YYMARKER;
	if(yyaccept <= 1) {
		if(yyaccept <= 0) {
			goto yy3;
		} else {
			goto yy5;
		}
	} else {
		goto yy7;
	}
yy19:
	yych = *++YYCURSOR;
	if(yych != '-') goto yy18;
yy20:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == '-') goto yy20;
#line 221 "mwlib/_uscan.re"
	{RET(t_hrule);}
#line 314 "mwlib/_uscan.cc"
yy23:
	++YYCURSOR;
	yych = *YYCURSOR;
yy24:
	if(yych <= ')') {
		if(yych == '#') goto yy23;
		goto yy7;
	} else {
		if(yych <= '*') goto yy23;
		if(yych <= '9') goto yy7;
		if(yych <= ';') goto yy23;
		goto yy7;
	}
yy25:
	++YYCURSOR;
	yych = *YYCURSOR;
yy26:
	if(yych == 0x0009) goto yy25;
	if(yych == ' ') goto yy25;
	goto yy13;
yy27:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= 0x001F) {
		if(yych == 0x0009) goto yy25;
		goto yy13;
	} else {
		if(yych <= ' ') goto yy25;
		if(yych == '=') goto yy27;
		goto yy13;
	}
yy29:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == '+') goto yy29;
#line 205 "mwlib/_uscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 360 "mwlib/_uscan.cc"
yy32:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == '-') goto yy32;
#line 180 "mwlib/_uscan.re"
	{
		if (tablemode) 
			RET(t_row);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 375 "mwlib/_uscan.cc"
yy35:
	++YYCURSOR;
#line 177 "mwlib/_uscan.re"
	{--tablemode; RET(t_end_table);}
#line 380 "mwlib/_uscan.cc"
yy37:
	++YYCURSOR;
#line 176 "mwlib/_uscan.re"
	{++tablemode; RET(t_begin_table);}
#line 385 "mwlib/_uscan.cc"
yy39:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '9') {
		if(yych <= '#') {
			if(yych <= '"') goto yy7;
			goto yy23;
		} else {
			if(yych == '*') goto yy23;
			goto yy7;
		}
	} else {
		if(yych <= ';') {
			if(yych <= ':') goto yy39;
			goto yy23;
		} else {
			if(yych != '{') goto yy7;
		}
	}
yy41:
	yych = *++YYCURSOR;
	if(yych == '|') goto yy37;
	goto yy18;
yy42:
	yych = *++YYCURSOR;
	if(yych <= ',') {
		if(yych == '+') goto yy29;
		goto yy10;
	} else {
		if(yych <= '-') goto yy32;
		if(yych == '}') goto yy35;
		goto yy10;
	}
yy43:
	++YYCURSOR;
	yych = *YYCURSOR;
yy44:
	if(yych <= '!') {
		if(yych <= 0x0009) {
			if(yych <= 0x0008) goto yy18;
			goto yy43;
		} else {
			if(yych <= 0x001F) goto yy18;
			if(yych <= ' ') goto yy43;
		}
	} else {
		if(yych <= 'z') {
			if(yych == ':') goto yy46;
			goto yy18;
		} else {
			if(yych <= '{') goto yy41;
			if(yych <= '|') goto yy42;
			goto yy18;
		}
	}
	yych = *++YYCURSOR;
	goto yy10;
yy46:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == ':') goto yy46;
	if(yych == '{') goto yy41;
	goto yy18;
}
#line 224 "mwlib/_uscan.re"



not_bol:
	cursor = save_cursor;
	marker = cursor;


#line 460 "mwlib/_uscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	yych = *YYCURSOR;
	if(yych <= '\\') {
		if(yych <= '/') {
			if(yych <= ' ') {
				if(yych <= 0x0000) goto yy74;
				if(yych == 0x000A) goto yy66;
				goto yy76;
			} else {
				if(yych <= '%') {
					if(yych <= '!') goto yy69;
					goto yy76;
				} else {
					if(yych <= '&') goto yy73;
					if(yych <= '\'') goto yy71;
					goto yy76;
				}
			}
		} else {
			if(yych <= '<') {
				if(yych <= '9') goto yy62;
				if(yych <= ':') goto yy70;
				if(yych <= ';') goto yy76;
				goto yy72;
			} else {
				if(yych <= '@') {
					if(yych <= '=') goto yy64;
					goto yy76;
				} else {
					if(yych <= 'Z') goto yy62;
					if(yych >= '\\') goto yy76;
				}
			}
		}
	} else {
		if(yych <= 'i') {
			if(yych <= '`') {
				if(yych <= ']') goto yy63;
				if(yych == '_') goto yy58;
				goto yy76;
			} else {
				if(yych <= 'f') {
					if(yych <= 'e') goto yy62;
					goto yy56;
				} else {
					if(yych <= 'g') goto yy62;
					if(yych <= 'h') goto yy57;
					goto yy54;
				}
			}
		} else {
			if(yych <= 'z') {
				if(yych <= 'l') goto yy62;
				if(yych <= 'm') goto yy52;
				if(yych <= 'n') goto yy55;
				goto yy62;
			} else {
				if(yych <= '|') {
					if(yych <= '{') goto yy76;
					goto yy68;
				} else {
					if(yych == 0x007F) goto yy60;
					goto yy76;
				}
			}
		}
	}
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch(yych) {
	case '[':	goto yy325;
	case 'f':	goto yy328;
	case 'h':	goto yy327;
	case 'i':	goto yy330;
	case 'm':	goto yy331;
	case 'n':	goto yy329;
	default:	goto yy51;
	}
yy51:
#line 289 "mwlib/_uscan.re"
	{RET(t_special);}
#line 544 "mwlib/_uscan.cc"
yy52:
	++YYCURSOR;
	if((yych = *YYCURSOR) == 'a') goto yy313;
	goto yy123;
yy53:
#line 245 "mwlib/_uscan.re"
	{RET(t_text);}
#line 552 "mwlib/_uscan.cc"
yy54:
	yych = *++YYCURSOR;
	if(yych == 'r') goto yy305;
	goto yy123;
yy55:
	yych = *++YYCURSOR;
	if(yych == 'e') goto yy298;
	goto yy123;
yy56:
	yych = *++YYCURSOR;
	if(yych == 't') goto yy290;
	goto yy123;
yy57:
	yych = *++YYCURSOR;
	if(yych == 't') goto yy280;
	goto yy123;
yy58:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '_') goto yy144;
yy59:
#line 246 "mwlib/_uscan.re"
	{RET(t_text);}
#line 575 "mwlib/_uscan.cc"
yy60:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'U') goto yy124;
yy61:
#line 299 "mwlib/_uscan.re"
	{RET(t_text);}
#line 583 "mwlib/_uscan.cc"
yy62:
	yych = *++YYCURSOR;
	goto yy123;
yy63:
	yych = *++YYCURSOR;
	if(yych == ']') goto yy120;
	goto yy51;
yy64:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '=') goto yy118;
	goto yy117;
yy65:
#line 249 "mwlib/_uscan.re"
	{
			if (eol()) {
			        if (line_startswith_section>=0) {
				     line_startswith_section=-1;
				     RET(t_section_end);
                                } else {
				     RET(t_text);
                                }
			} else {
				RET(t_text);
			}
		    }
#line 609 "mwlib/_uscan.cc"
yy66:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 0x000A) goto yy111;
	if(yych == ' ') goto yy114;
yy67:
#line 271 "mwlib/_uscan.re"
	{newline(); RET(t_newline);}
#line 618 "mwlib/_uscan.cc"
yy68:
	yych = *++YYCURSOR;
	if(yych <= '*') {
		if(yych == '!') goto yy107;
		goto yy51;
	} else {
		if(yych <= '+') goto yy109;
		if(yych == '|') goto yy107;
		goto yy51;
	}
yy69:
	yych = *++YYCURSOR;
	if(yych == '!') goto yy107;
	goto yy61;
yy70:
	yych = *++YYCURSOR;
	goto yy51;
yy71:
	yych = *++YYCURSOR;
	if(yych == '\'') goto yy104;
	goto yy61;
yy72:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/') {
		if(yych == '!') goto yy88;
		if(yych <= '.') goto yy61;
		goto yy89;
	} else {
		if(yych <= 'Z') {
			if(yych <= '@') goto yy61;
			goto yy90;
		} else {
			if(yych <= '`') goto yy61;
			if(yych <= 'z') goto yy90;
			goto yy61;
		}
	}
yy73:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9') {
		if(yych == '#') goto yy77;
		if(yych <= '/') goto yy61;
		goto yy79;
	} else {
		if(yych <= 'Z') {
			if(yych <= '@') goto yy61;
			goto yy79;
		} else {
			if(yych <= '`') goto yy61;
			if(yych <= 'z') goto yy79;
			goto yy61;
		}
	}
yy74:
	++YYCURSOR;
#line 298 "mwlib/_uscan.re"
	{newline(); return t_end;}
#line 678 "mwlib/_uscan.cc"
yy76:
	yych = *++YYCURSOR;
	goto yy61;
yy77:
	yych = *++YYCURSOR;
	if(yych <= 'W') {
		if(yych <= '/') goto yy78;
		if(yych <= '9') goto yy84;
	} else {
		if(yych <= 'X') goto yy83;
		if(yych == 'x') goto yy83;
	}
yy78:
	YYCURSOR = YYMARKER;
	if(yyaccept <= 2) {
		if(yyaccept <= 1) {
			if(yyaccept <= 0) {
				goto yy51;
			} else {
				goto yy61;
			}
		} else {
			goto yy67;
		}
	} else {
		if(yyaccept <= 4) {
			if(yyaccept <= 3) {
				goto yy113;
			} else {
				goto yy59;
			}
		} else {
			goto yy53;
		}
	}
yy79:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= ';') {
		if(yych <= '/') goto yy78;
		if(yych <= '9') goto yy79;
		if(yych <= ':') goto yy78;
	} else {
		if(yych <= 'Z') {
			if(yych <= '@') goto yy78;
			goto yy79;
		} else {
			if(yych <= '`') goto yy78;
			if(yych <= 'z') goto yy79;
			goto yy78;
		}
	}
yy81:
	++YYCURSOR;
#line 296 "mwlib/_uscan.re"
	{RET(t_entity);}
#line 735 "mwlib/_uscan.cc"
yy83:
	yych = *++YYCURSOR;
	if(yych == ';') goto yy78;
	goto yy87;
yy84:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '/') goto yy78;
	if(yych <= '9') goto yy84;
	if(yych == ';') goto yy81;
	goto yy78;
yy86:
	++YYCURSOR;
	yych = *YYCURSOR;
yy87:
	if(yych <= ';') {
		if(yych <= '/') goto yy78;
		if(yych <= '9') goto yy86;
		if(yych <= ':') goto yy78;
		goto yy81;
	} else {
		if(yych <= 'F') {
			if(yych <= '@') goto yy78;
			goto yy86;
		} else {
			if(yych <= '`') goto yy78;
			if(yych <= 'f') goto yy86;
			goto yy78;
		}
	}
yy88:
	yych = *++YYCURSOR;
	if(yych == '-') goto yy96;
	goto yy78;
yy89:
	yych = *++YYCURSOR;
	if(yych <= '@') goto yy78;
	if(yych <= 'Z') goto yy90;
	if(yych <= '`') goto yy78;
	if(yych >= '{') goto yy78;
yy90:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '>') {
		if(yych <= ';') {
			if(yych <= 0x0000) goto yy78;
		} else {
			if(yych <= '<') goto yy78;
			if(yych >= '>') goto yy94;
		}
	} else {
		if(yych <= 'Z') {
			if(yych >= 'A') goto yy90;
		} else {
			if(yych <= '`') goto yy92;
			if(yych <= 'z') goto yy90;
		}
	}
yy92:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '<') {
		if(yych <= 0x0000) goto yy78;
		if(yych <= ';') goto yy92;
		goto yy78;
	} else {
		if(yych != '>') goto yy92;
	}
yy94:
	++YYCURSOR;
#line 292 "mwlib/_uscan.re"
	{RET(t_html_tag);}
#line 808 "mwlib/_uscan.cc"
yy96:
	yych = *++YYCURSOR;
	if(yych != '-') goto yy78;
yy97:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= ';') {
		if(yych <= 0x0000) goto yy78;
		if(yych != '-') goto yy97;
	} else {
		if(yych == '=') goto yy97;
		if(yych <= '>') goto yy78;
		goto yy97;
	}
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= ';') {
		if(yych <= 0x0000) goto yy78;
		if(yych != '-') goto yy97;
	} else {
		if(yych == '=') goto yy97;
		if(yych <= '>') goto yy78;
		goto yy97;
	}
yy100:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= ';') {
		if(yych <= 0x0000) goto yy78;
		if(yych == '-') goto yy100;
		goto yy97;
	} else {
		if(yych <= '<') goto yy78;
		if(yych != '>') goto yy97;
	}
	++YYCURSOR;
#line 295 "mwlib/_uscan.re"
	{RET(t_comment);}
#line 847 "mwlib/_uscan.cc"
yy104:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == '\'') goto yy104;
#line 290 "mwlib/_uscan.re"
	{RET(t_singlequote);}
#line 854 "mwlib/_uscan.cc"
yy107:
	++YYCURSOR;
#line 273 "mwlib/_uscan.re"
	{
		if (tablemode) {
		        if (cursor[-2]!='!' || cursor[-2]==lineflags.rowchar) {
			       RET(t_column);
			}
		}
		cursor = start+1;
		RET(t_special);
	}
#line 867 "mwlib/_uscan.cc"
yy109:
	++YYCURSOR;
#line 283 "mwlib/_uscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		cursor = start+1;
		RET(t_special);
	}
#line 877 "mwlib/_uscan.cc"
yy111:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == 0x000A) goto yy111;
	if(yych == ' ') goto yy114;
yy113:
#line 262 "mwlib/_uscan.re"
	{newline();
		 Py_UNICODE *tmp = cursor;

		 cursor = start+1;
		 found(t_newline);
		 start += 1;
		 cursor = tmp;  
		 RET(t_break);
		}
#line 895 "mwlib/_uscan.cc"
yy114:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == 0x000A) goto yy111;
	if(yych == ' ') goto yy114;
	goto yy78;
yy116:
	++YYCURSOR;
	yych = *YYCURSOR;
yy117:
	if(yych == 0x0009) goto yy116;
	if(yych == ' ') goto yy116;
	goto yy65;
yy118:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= 0x001F) {
		if(yych == 0x0009) goto yy116;
		goto yy65;
	} else {
		if(yych <= ' ') goto yy116;
		if(yych == '=') goto yy118;
		goto yy65;
	}
yy120:
	++YYCURSOR;
#line 248 "mwlib/_uscan.re"
	{RET(t_2box_close);}
#line 924 "mwlib/_uscan.cc"
yy122:
	++YYCURSOR;
	yych = *YYCURSOR;
yy123:
	if(yych <= '@') {
		if(yych <= '/') goto yy53;
		if(yych <= '9') goto yy122;
		goto yy53;
	} else {
		if(yych <= 'Z') goto yy122;
		if(yych <= '`') goto yy53;
		if(yych <= 'z') goto yy122;
		goto yy53;
	}
yy124:
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'Q') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '-') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '-') goto yy78;
	goto yy130;
yy129:
	++YYCURSOR;
	yych = *YYCURSOR;
yy130:
	if(yych <= '/') {
		if(yych != '-') goto yy78;
	} else {
		if(yych <= '9') goto yy129;
		if(yych <= '`') goto yy78;
		if(yych <= 'z') goto yy129;
		goto yy78;
	}
	yych = *++YYCURSOR;
	if(yych <= '/') goto yy78;
	if(yych >= ':') goto yy78;
yy132:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == '-') goto yy134;
	if(yych <= '/') goto yy78;
	if(yych <= '9') goto yy132;
	goto yy78;
yy134:
	yych = *++YYCURSOR;
	if(yych == '-') goto yy78;
	goto yy136;
yy135:
	++YYCURSOR;
	yych = *YYCURSOR;
yy136:
	if(yych <= '/') {
		if(yych != '-') goto yy78;
	} else {
		if(yych <= '9') goto yy135;
		if(yych <= '`') goto yy78;
		if(yych <= 'f') goto yy135;
		goto yy78;
	}
	yych = *++YYCURSOR;
	if(yych != 'Q') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'U') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 0x007F) goto yy78;
	++YYCURSOR;
#line 243 "mwlib/_uscan.re"
	{RET(t_uniq);}
#line 1002 "mwlib/_uscan.cc"
yy144:
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	switch(yych) {
	case 'E':	goto yy148;
	case 'F':	goto yy147;
	case 'N':	goto yy146;
	case 'S':	goto yy149;
	case 'T':	goto yy145;
	default:	goto yy151;
	}
yy145:
	yych = *++YYCURSOR;
	if(yych == 'O') goto yy277;
	goto yy78;
yy146:
	yych = *++YYCURSOR;
	if(yych <= 'N') {
		if(yych == 'E') goto yy172;
		goto yy78;
	} else {
		if(yych <= 'O') goto yy170;
		if(yych == 'U') goto yy171;
		goto yy78;
	}
yy147:
	yych = *++YYCURSOR;
	if(yych == 'O') goto yy162;
	goto yy78;
yy148:
	yych = *++YYCURSOR;
	if(yych == 'N') goto yy159;
	goto yy78;
yy149:
	yych = *++YYCURSOR;
	if(yych == 'T') goto yy152;
	goto yy78;
yy150:
	++YYCURSOR;
	yych = *YYCURSOR;
yy151:
	if(yych == '_') goto yy150;
	goto yy59;
yy152:
	yych = *++YYCURSOR;
	if(yych != 'A') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
yy157:
	++YYCURSOR;
#line 242 "mwlib/_uscan.re"
	{RET(t_magicword);}
#line 1061 "mwlib/_uscan.cc"
yy159:
	yych = *++YYCURSOR;
	if(yych != 'D') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy162:
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy170:
	yych = *++YYCURSOR;
	switch(yych) {
	case 'C':	goto yy203;
	case 'E':	goto yy202;
	case 'G':	goto yy204;
	case 'N':	goto yy205;
	case 'T':	goto yy201;
	default:	goto yy78;
	}
yy171:
	yych = *++YYCURSOR;
	if(yych == 'M') goto yy186;
	goto yy78;
yy172:
	yych = *++YYCURSOR;
	if(yych != 'W') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'S') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'L') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'K') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy186:
	yych = *++YYCURSOR;
	if(yych != 'B') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'D') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'H') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'A') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'D') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'G') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'S') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy201:
	yych = *++YYCURSOR;
	if(yych <= 'H') {
		if(yych == 'C') goto yy257;
		goto yy78;
	} else {
		if(yych <= 'I') goto yy258;
		if(yych == 'O') goto yy256;
		goto yy78;
	}
yy202:
	yych = *++YYCURSOR;
	if(yych == 'D') goto yy245;
	goto yy78;
yy203:
	yych = *++YYCURSOR;
	if(yych == 'C') goto yy229;
	if(yych == 'O') goto yy230;
	goto yy78;
yy204:
	yych = *++YYCURSOR;
	if(yych == 'A') goto yy222;
	goto yy78;
yy205:
	yych = *++YYCURSOR;
	if(yych != 'U') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'M') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'B') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'D') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'H') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'A') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'D') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'G') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'S') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy222:
	yych = *++YYCURSOR;
	if(yych != 'L') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'L') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'Y') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy229:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy244;
	goto yy78;
yy230:
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'V') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy244:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy245:
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'S') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy256:
	yych = *++YYCURSOR;
	if(yych == 'C') goto yy271;
	goto yy78;
yy257:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy270;
	goto yy78;
yy258:
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'L') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'V') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy270:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy271:
	yych = *++YYCURSOR;
	if(yych == 'N') goto yy272;
	if(yych == '_') goto yy273;
	goto yy78;
yy272:
	yych = *++YYCURSOR;
	if(yych == 'U') goto yy274;
	goto yy78;
yy273:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy274:
	yych = *++YYCURSOR;
	if(yych != 'M') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy277:
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy157;
	goto yy78;
yy280:
	yych = *++YYCURSOR;
	if(yych != 't') goto yy123;
	yych = *++YYCURSOR;
	if(yych != 'p') goto yy123;
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == ':') goto yy284;
	if(yych != 's') goto yy123;
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != ':') goto yy123;
yy284:
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych <= '~') {
		if(yych <= '=') {
			if(yych <= '"') {
				if(yych != '!') goto yy78;
			} else {
				if(yych == '<') goto yy78;
			}
		} else {
			if(yych <= '^') {
				if(yych <= '>') goto yy78;
				if(yych >= '[') goto yy78;
			} else {
				if(yych == '`') goto yy78;
			}
		}
	} else {
		if(yych <= 0x00DC) {
			if(yych <= 0x00D5) {
				if(yych != 0x00C4) goto yy78;
			} else {
				if(yych <= 0x00D6) goto yy287;
				if(yych <= 0x00DB) goto yy78;
			}
		} else {
			if(yych <= 0x00F5) {
				if(yych != 0x00E4) goto yy78;
			} else {
				if(yych <= 0x00F6) goto yy287;
				if(yych != 0x00FC) goto yy78;
			}
		}
	}
yy287:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '~') {
		if(yych <= '=') {
			if(yych <= '"') {
				if(yych == '!') goto yy287;
			} else {
				if(yych != '<') goto yy287;
			}
		} else {
			if(yych <= '^') {
				if(yych <= '>') goto yy289;
				if(yych <= 'Z') goto yy287;
			} else {
				if(yych != '`') goto yy287;
			}
		}
	} else {
		if(yych <= 0x00DC) {
			if(yych <= 0x00D5) {
				if(yych == 0x00C4) goto yy287;
			} else {
				if(yych <= 0x00D6) goto yy287;
				if(yych >= 0x00DC) goto yy287;
			}
		} else {
			if(yych <= 0x00F5) {
				if(yych == 0x00E4) goto yy287;
			} else {
				if(yych <= 0x00F6) goto yy287;
				if(yych == 0x00FC) goto yy287;
			}
		}
	}
yy289:
#line 241 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1456 "mwlib/_uscan.cc"
yy290:
	yych = *++YYCURSOR;
	if(yych != 'p') goto yy123;
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != ':') goto yy123;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych <= '>') {
		if(yych <= '%') {
			if(yych <= '"') goto yy78;
			if(yych >= '%') goto yy78;
		} else {
			if(yych <= ':') goto yy295;
			if(yych != '=') goto yy78;
		}
	} else {
		if(yych <= '`') {
			if(yych <= 'Z') goto yy295;
			if(yych != '_') goto yy78;
		} else {
			if(yych == '|') goto yy78;
			if(yych >= 0x007F) goto yy78;
		}
	}
yy295:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '>') {
		if(yych <= '%') {
			if(yych <= '"') goto yy297;
			if(yych <= '$') goto yy295;
		} else {
			if(yych <= ':') goto yy295;
			if(yych == '=') goto yy295;
		}
	} else {
		if(yych <= '`') {
			if(yych <= 'Z') goto yy295;
			if(yych == '_') goto yy295;
		} else {
			if(yych == '|') goto yy297;
			if(yych <= '~') goto yy295;
		}
	}
yy297:
#line 239 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1508 "mwlib/_uscan.cc"
yy298:
	yych = *++YYCURSOR;
	if(yych != 'w') goto yy123;
	yych = *++YYCURSOR;
	if(yych != 's') goto yy123;
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != ':') goto yy123;
	yych = *++YYCURSOR;
	if(yych <= '/') {
		if(yych != '.') goto yy78;
	} else {
		if(yych <= '9') goto yy302;
		if(yych <= '@') goto yy78;
		if(yych >= 'b') goto yy78;
	}
yy302:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '/') {
		if(yych == '.') goto yy302;
	} else {
		if(yych <= '9') goto yy302;
		if(yych <= '@') goto yy304;
		if(yych <= 'a') goto yy302;
	}
yy304:
#line 237 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1538 "mwlib/_uscan.cc"
yy305:
	yych = *++YYCURSOR;
	if(yych != 'c') goto yy123;
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != ':') goto yy123;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '-') goto yy78;
		if(yych >= ':') goto yy78;
	} else {
		if(yych <= 'Z') goto yy310;
		if(yych <= '`') goto yy78;
		if(yych >= '{') goto yy78;
	}
yy310:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '@') {
		if(yych <= '-') goto yy312;
		if(yych <= '9') goto yy310;
	} else {
		if(yych <= 'Z') goto yy310;
		if(yych <= '`') goto yy312;
		if(yych <= 'z') goto yy310;
	}
yy312:
#line 235 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1572 "mwlib/_uscan.cc"
yy313:
	yych = *++YYCURSOR;
	if(yych != 'i') goto yy123;
	yych = *++YYCURSOR;
	if(yych != 'l') goto yy123;
	yych = *++YYCURSOR;
	if(yych != 't') goto yy123;
	yych = *++YYCURSOR;
	if(yych != 'o') goto yy123;
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != ':') goto yy123;
	yych = *++YYCURSOR;
	if(yych == '@') goto yy78;
	goto yy320;
yy319:
	++YYCURSOR;
	yych = *YYCURSOR;
yy320:
	if(yych <= '9') {
		if(yych <= '\'') {
			if(yych == '!') goto yy319;
			if(yych <= '"') goto yy78;
			goto yy319;
		} else {
			if(yych <= ')') goto yy78;
			if(yych == ',') goto yy78;
			goto yy319;
		}
	} else {
		if(yych <= '?') {
			if(yych == '=') goto yy319;
			if(yych <= '>') goto yy78;
			goto yy319;
		} else {
			if(yych <= 'Z') {
				if(yych >= 'A') goto yy319;
			} else {
				if(yych <= ']') goto yy78;
				if(yych <= '~') goto yy319;
				goto yy78;
			}
		}
	}
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '.') {
			if(yych <= ',') goto yy78;
		} else {
			if(yych <= '/') goto yy78;
			if(yych >= ':') goto yy78;
		}
	} else {
		if(yych <= '_') {
			if(yych <= 'Z') goto yy322;
			if(yych <= '^') goto yy78;
		} else {
			if(yych <= '`') goto yy78;
			if(yych >= '{') goto yy78;
		}
	}
yy322:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '@') {
		if(yych <= '.') {
			if(yych >= '-') goto yy322;
		} else {
			if(yych <= '/') goto yy324;
			if(yych <= '9') goto yy322;
		}
	} else {
		if(yych <= '_') {
			if(yych <= 'Z') goto yy322;
			if(yych >= '_') goto yy322;
		} else {
			if(yych <= '`') goto yy324;
			if(yych <= 'z') goto yy322;
		}
	}
yy324:
#line 233 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1656 "mwlib/_uscan.cc"
yy325:
	++YYCURSOR;
#line 247 "mwlib/_uscan.re"
	{RET(t_2box_open);}
#line 1661 "mwlib/_uscan.cc"
yy327:
	yych = *++YYCURSOR;
	if(yych == 't') goto yy367;
	goto yy78;
yy328:
	yych = *++YYCURSOR;
	if(yych == 't') goto yy359;
	goto yy78;
yy329:
	yych = *++YYCURSOR;
	if(yych == 'e') goto yy352;
	goto yy78;
yy330:
	yych = *++YYCURSOR;
	if(yych == 'r') goto yy344;
	goto yy78;
yy331:
	yych = *++YYCURSOR;
	if(yych != 'a') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'i') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'l') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 't') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'o') goto yy78;
	yych = *++YYCURSOR;
	if(yych != ':') goto yy78;
	yych = *++YYCURSOR;
	if(yych == '@') goto yy78;
	goto yy339;
yy338:
	++YYCURSOR;
	yych = *YYCURSOR;
yy339:
	if(yych <= '9') {
		if(yych <= '\'') {
			if(yych == '!') goto yy338;
			if(yych <= '"') goto yy78;
			goto yy338;
		} else {
			if(yych <= ')') goto yy78;
			if(yych == ',') goto yy78;
			goto yy338;
		}
	} else {
		if(yych <= '?') {
			if(yych == '=') goto yy338;
			if(yych <= '>') goto yy78;
			goto yy338;
		} else {
			if(yych <= 'Z') {
				if(yych >= 'A') goto yy338;
			} else {
				if(yych <= ']') goto yy78;
				if(yych <= '~') goto yy338;
				goto yy78;
			}
		}
	}
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '.') {
			if(yych <= ',') goto yy78;
		} else {
			if(yych <= '/') goto yy78;
			if(yych >= ':') goto yy78;
		}
	} else {
		if(yych <= '_') {
			if(yych <= 'Z') goto yy341;
			if(yych <= '^') goto yy78;
		} else {
			if(yych <= '`') goto yy78;
			if(yych >= '{') goto yy78;
		}
	}
yy341:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '@') {
		if(yych <= '.') {
			if(yych >= '-') goto yy341;
		} else {
			if(yych <= '/') goto yy343;
			if(yych <= '9') goto yy341;
		}
	} else {
		if(yych <= '_') {
			if(yych <= 'Z') goto yy341;
			if(yych >= '_') goto yy341;
		} else {
			if(yych <= '`') goto yy343;
			if(yych <= 'z') goto yy341;
		}
	}
yy343:
#line 232 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1762 "mwlib/_uscan.cc"
yy344:
	yych = *++YYCURSOR;
	if(yych != 'c') goto yy78;
	yych = *++YYCURSOR;
	if(yych != ':') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '-') goto yy78;
		if(yych >= ':') goto yy78;
	} else {
		if(yych <= 'Z') goto yy349;
		if(yych <= '`') goto yy78;
		if(yych >= '{') goto yy78;
	}
yy349:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '@') {
		if(yych <= '-') goto yy351;
		if(yych <= '9') goto yy349;
	} else {
		if(yych <= 'Z') goto yy349;
		if(yych <= '`') goto yy351;
		if(yych <= 'z') goto yy349;
	}
yy351:
#line 234 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1795 "mwlib/_uscan.cc"
yy352:
	yych = *++YYCURSOR;
	if(yych != 'w') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 's') goto yy78;
	yych = *++YYCURSOR;
	if(yych != ':') goto yy78;
	yych = *++YYCURSOR;
	if(yych <= '/') {
		if(yych != '.') goto yy78;
	} else {
		if(yych <= '9') goto yy356;
		if(yych <= '@') goto yy78;
		if(yych >= 'b') goto yy78;
	}
yy356:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '/') {
		if(yych == '.') goto yy356;
	} else {
		if(yych <= '9') goto yy356;
		if(yych <= '@') goto yy358;
		if(yych <= 'a') goto yy356;
	}
yy358:
#line 236 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1824 "mwlib/_uscan.cc"
yy359:
	yych = *++YYCURSOR;
	if(yych != 'p') goto yy78;
	yych = *++YYCURSOR;
	if(yych != ':') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych <= '>') {
		if(yych <= '%') {
			if(yych <= '"') goto yy78;
			if(yych >= '%') goto yy78;
		} else {
			if(yych <= ':') goto yy364;
			if(yych != '=') goto yy78;
		}
	} else {
		if(yych <= '`') {
			if(yych <= 'Z') goto yy364;
			if(yych != '_') goto yy78;
		} else {
			if(yych == '|') goto yy78;
			if(yych >= 0x007F) goto yy78;
		}
	}
yy364:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '>') {
		if(yych <= '%') {
			if(yych <= '"') goto yy366;
			if(yych <= '$') goto yy364;
		} else {
			if(yych <= ':') goto yy364;
			if(yych == '=') goto yy364;
		}
	} else {
		if(yych <= '`') {
			if(yych <= 'Z') goto yy364;
			if(yych == '_') goto yy364;
		} else {
			if(yych == '|') goto yy366;
			if(yych <= '~') goto yy364;
		}
	}
yy366:
#line 238 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1875 "mwlib/_uscan.cc"
yy367:
	yych = *++YYCURSOR;
	if(yych != 't') goto yy78;
	yych = *++YYCURSOR;
	if(yych != 'p') goto yy78;
	yych = *++YYCURSOR;
	if(yych == ':') goto yy371;
	if(yych != 's') goto yy78;
	yych = *++YYCURSOR;
	if(yych != ':') goto yy78;
yy371:
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if(yych <= '~') {
		if(yych <= '=') {
			if(yych <= '"') {
				if(yych != '!') goto yy78;
			} else {
				if(yych == '<') goto yy78;
			}
		} else {
			if(yych <= '^') {
				if(yych <= '>') goto yy78;
				if(yych >= '[') goto yy78;
			} else {
				if(yych == '`') goto yy78;
			}
		}
	} else {
		if(yych <= 0x00DC) {
			if(yych <= 0x00D5) {
				if(yych != 0x00C4) goto yy78;
			} else {
				if(yych <= 0x00D6) goto yy374;
				if(yych <= 0x00DB) goto yy78;
			}
		} else {
			if(yych <= 0x00F5) {
				if(yych != 0x00E4) goto yy78;
			} else {
				if(yych <= 0x00F6) goto yy374;
				if(yych != 0x00FC) goto yy78;
			}
		}
	}
yy374:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '~') {
		if(yych <= '=') {
			if(yych <= '"') {
				if(yych == '!') goto yy374;
			} else {
				if(yych != '<') goto yy374;
			}
		} else {
			if(yych <= '^') {
				if(yych <= '>') goto yy376;
				if(yych <= 'Z') goto yy374;
			} else {
				if(yych != '`') goto yy374;
			}
		}
	} else {
		if(yych <= 0x00DC) {
			if(yych <= 0x00D5) {
				if(yych == 0x00C4) goto yy374;
			} else {
				if(yych <= 0x00D6) goto yy374;
				if(yych >= 0x00DC) goto yy374;
			}
		} else {
			if(yych <= 0x00F5) {
				if(yych == 0x00E4) goto yy374;
			} else {
				if(yych <= 0x00F6) goto yy374;
				if(yych == 0x00FC) goto yy374;
			}
		}
	}
yy376:
#line 240 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1962 "mwlib/_uscan.cc"
}
#line 300 "mwlib/_uscan.re"

}


PyObject *py_scan(PyObject *self, PyObject *args) 
{
	PyObject *arg1;
	if (!PyArg_ParseTuple(args, "O:mwscan.scan", &arg1)) {
		return 0;
	}
	PyUnicodeObject *unistr = (PyUnicodeObject*)PyUnicode_FromObject(arg1);
	if (unistr == NULL) {
		PyErr_SetString(PyExc_TypeError,
				"parameter cannot be converted to unicode in mwscan.scan");
		return 0;
	}

	Py_UNICODE *start = unistr->str;
	Py_UNICODE *end = start+unistr->length;
	

	Scanner scanner (start, end);
	Py_BEGIN_ALLOW_THREADS
	while (scanner.scan()) {
	}
	Py_END_ALLOW_THREADS
	Py_XDECREF(unistr);
	
	// return PyList_New(0); // uncomment to see timings for scanning

	int size = scanner.tokens.size();
	PyObject *result = PyList_New(size);
	if (!result) {
		return 0;
	}
	
	for (int i=0; i<size; i++) {
		Token t = scanner.tokens[i];
		PyList_SET_ITEM(result, i, Py_BuildValue("iii", t.type, t.start, t.len));
	}
	
	return result;
}



static PyMethodDef module_functions[] = {
	{"scan", (PyCFunction)py_scan, METH_VARARGS, "scan(text)"},
	{0, 0},
};



extern "C" {
	DL_EXPORT(void) init_uscan();
}

DL_EXPORT(void) init_uscan()
{
	/*PyObject *m =*/ Py_InitModule("_uscan", module_functions);
}
